# vim: set ft=spec: -*- rpm-spec -*-
# $Id: evms,v 1.201 2004/06/22 14:51:22 tren Exp $
#
%def_with x

%define  patch_name kernel-feat-evms
%define  src_patches_dir kernel/2.4
%define  src_patches_dir_26 kernel/2.6
%define  klabel_24 2.4
%define  klabel_26 2.6
%define  klabel_263 10_apply_to_2.6.3
%define  klabel_264 10_apply_to_2.6.4
%define  klabel_265 10_apply_to_2.6.5

Name: evms
Version: 2.3.3
Release: alt3

Summary: Enterprise Volume Management System utilities
License: GPL
Group: System/Kernel and hardware
Url: http://www.sourceforge.net/projects/evms
Packager: Zhenja Kaluta <tren@altlinux.ru>

Source0: http://prdownloads.sourceforge.net/%name/%name-%version.tar.gz
Source1: startevms
Source2: 00011.patch
Source3: 00013.patch
Source4: 00018.patch
Source5: 00022.patch
Source6: 00024.patch

Patch0: %name-2.3.2-pipe.patch
Patch1: %name-2.2.2-delayed_discovery.patch.bz2
Patch2: %name-2.3.2-cli-print_value.patch
Patch3: %name-2.1.0-noncurses.patch
Patch4: %name-2.1.1-alt-arm-nodirect.patch
Patch5: %name-2.2.2-raid1_discovery.patch
Patch6: %name-2.3.0-md_discover.patch
Patch7: %name-2.2.2-engine-is_mounted.patch

%ifarch %ix86
BuildPreReq: kernel-build-tools
%endif

BuildRequires: glib-devel libe2fs-devel libncurses-devel libreadline-devel libtinfo-devel

%if_with x
BuildRequires: XFree86-devel gtk+-devel
%endif

Conflicts: lvm

%package -n lib%name
Summary: Enterprise Volume Management System libraries
Group: System/Libraries

%package -n lib%name-devel
Summary: Enterprise Volume Management System development part
Group: Development/C
Requires: lib%name = %version-%release
Provides: %name-devel = %version-%release

%package -n %name-cli
Summary: EVMS commandline tool
Group: System/Kernel and hardware
Requires: evms = %version-%release

%package -n %name-ncurses
Summary: EVMS UI
Group: System/Kernel and hardware
Requires: evms = %version-%release

%package -n %name-gui
Summary: EVMS GUI
Group: System/Kernel and hardware
Requires: evms = %version-%release

%package -n %patch_name
Summary: %patch_name kernel patch - Enterprise Volume Manager System
Group: Development/Other

%package -n %patch_name-nodm
Summary: %patch_name kernel patch - Enterprise Volume Manager System for nodm system
Group: Development/Other


%description
This package contains the user-space tools needed to manage EVMS (Enterprise
Volume Management System) volumes.

In order to use these user-space tools, you must also have your kernel patched
with the most recent EVMS code. This code is available in the source package
on the project web page http://www.sf.net/projects/evms/

Please see the EVMS-HOWTO on the project web page or in the source package
for detailed instructions on patching your kernel with EVMS and using the
tools after installation.

%description -n lib%name
This package contains libs needed to manage EVMS (Enterprise
Volume Management System) volumes.

%description -n lib%name-devel
This package contains develop tools needed to manage EVMS (Enterprise
Volume Management System) volumes.

%description -n %name-cli
Command line tool for EVMS

%description -n %name-ncurses
Ncurses ui tool for EVMS

%description -n %name-gui
GTK+ ui tool for EVMS

%description -n %patch_name
This patch adds support for EVMS, the Enterprise Volume Manager System.
It uses device mapper to work 

%description -n %patch_name-nodm
This patch adds support for EVMS, the Enterprise Volume Manager System.
It uses device mapper to work in case w/o extra dm patches

%prep
%setup -q
%patch0 -p1
#%patch1 -p1
%patch2 -p1
%patch3 -p1
%ifarch armv4b armv4l armv5b armv5l
%patch4 -p1
%endif
%patch5 -p1
%patch6 -p1
%patch7 -p1

%build
%__autoconf
%add_optflags -DEVMS_DEBUG
%configure  --libdir=/lib --sbindir=/sbin \
	--disable-s390 \
	--disable-gpt \
	--disable-aix \
	--disable-os2 \
%ifarch armv4b armv4l armv5b armv5l
	--disable-jfs \
	--disable-reiser \
	--disable-ha \
%endif
%if_without x
	--disable-gui \
	--disable-gtktest \
%endif
	#

%__make LD_LIBRARY_PATH=%buildroot/lib

%install
%__mkdir_p %buildroot{%_sysconfdir,%_libdir,%_sbindir/sbin}
%__make DESTDIR=%buildroot prefix=%buildroot%_prefix install
%__install -p -m 0755 %SOURCE1 %buildroot/sbin

%__mv %buildroot/sbin/%{?_with_x:{evmsn,evmsgui}}%{!?_with_x:evmsn} %buildroot%_sbindir/
for f in %buildroot/lib/*.so; do
    %__ln_s -f ../../lib/`readlink $f` %buildroot%_libdir/${f##*/}
done

%__mkdir_p %buildroot%_sysconfdir/sysconfig
%__cat <<EOF > %buildroot%_sysconfdir/sysconfig/%name
# if 'yes' tune evms.conf during evms startup
# to avoid scans on nonexistent legacy devices
EVMS_RECONFIG=no
EOF

# {{{ kernel patches

%ifarch %ix86
%__mkdir_p %patches_dir/%patch_name/{%klabel_24,%klabel_26}/01_kernel-fix-lvm
#################################################
#	Kernel patches	2.4			#
#################################################

%define need_patches dm-snapshot.patch dm-mpath.patch dm-bbr.patch
pushd .
cd %src_patches_dir

#for i in %need_patches; do
#	%__install -p -m 644 $i %patches_dir/%patch_name/%klabel_24/01_kernel-fix-lvm
#done
%__install -p -m 644 dm-snapshot.patch \
	%patches_dir/%patch_name/%klabel_24/01_kernel-fix-lvm/01_dm-snapshot.patch
%__install -p -m 644 dm-mpath.patch \
	%patches_dir/%patch_name/%klabel_24/01_kernel-fix-lvm/02_dm-mpath.patch
%__install -p -m 644 dm-bbr.patch \
	%patches_dir/%patch_name/%klabel_24/01_kernel-fix-lvm/03_dm-bbr.patch
popd

#################################################
#	Kernel patches	2.6			#
#################################################

#define need_patches bd-claim.patch  dm-bbr.patch  dm-origin.patch
%define need_patches dm-bbr.patch  dm-origin.patch

%__mkdir_p %patches_dir/%patch_name/%klabel_26/

(cd %src_patches_dir_26
for i in %need_patches; do
	%__install -p -m 644 $i %patches_dir/%patch_name/%klabel_26/
done
)

%define need_patches bd-claim.patch

%__mkdir_p %patches_dir/%patch_name-nodm/%klabel_26/

(cd %src_patches_dir_26
for i in %need_patches; do
	%__install -p -m 644 $i %patches_dir/%patch_name-nodm/%klabel_26/
done
)


#remove bbr patch because need kernel-fix-dm
#%__rm %patches_dir/%patch_name/%klabel_26/dm-bbr.patch

#Added dm-snapshot from udm patch

#%__install -p -m 644 %SOURCE2 %patches_dir/%patch_name/%klabel_26
#%__install -p -m 644 %SOURCE3 %patches_dir/%patch_name/%klabel_26
#%__install -p -m 644 %SOURCE4 %patches_dir/%patch_name/%klabel_26
#%__install -p -m 644 %SOURCE5 %patches_dir/%patch_name/%klabel_26
#%__install -p -m 644 %SOURCE6 %patches_dir/%patch_name/%klabel_26

###############################################
%endif # ix86

# }}}

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

%files
%doc doc/linuxrc ChangeLog INSTALL* README PLUGIN.IDS TERMINOLOGY
%config(noreplace) %_sysconfdir/%name.conf
%config(noreplace) %_sysconfdir/sysconfig/%name
/sbin/startevms
/sbin/%{name}_*
#/sbin/get_dev_num
%_man8dir/%{name}_*

%files -n lib%name
/lib/%name
#/lib/libdlist-*.so.*
/lib/lib%name-*.so.*
/lib/lib%name.so

%files -n lib%name-devel
#%_libdir/libdlist.so
%_libdir/lib%name.so
%_includedir/%name

%files -n %name-cli
/sbin/%name
%_man8dir/%name.*

%files -n %name-ncurses
%_sbindir/%{name}n

%if_with x
%files -n %name-gui
%_sbindir/%{name}gui
%endif

%ifarch %ix86
%files -n %patch_name
%patches/%patch_name
%files -n %patch_name-nodm
%patches/%patch_name-nodm
%endif

%changelog
* Tue Jun 22 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.3-alt3
- Fixed expr bug

* Thu May 13 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.3-alt2
- Removed db-claim

* Thu May 13 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.3-alt1
- New upstream release

* Tue May 11 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.2-alt3
- Removed lvm depends for 2.6

* Wed Apr 28 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.2-alt2
- Fixed library symlink

* Tue Apr 27 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.2-alt1
- New upstream release
- Updated cli-print_value.patch
- Updated pipe patch

* Mon Apr 26 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.1-alt1
- New upstream release

* Thu Apr 15 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.0-alt4
- Added nodm branch

* Wed Mar 17 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.0-alt3
- Removed bbr support
- Added snapshoting and multipath from udm patches

* Wed Mar 17 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.0-alt2
- Updated for 2.6.3 with 2.6.0-udm3

* Fri Mar 12 2004 Zhenja Kaluta <tren@altlinux.ru> 2.3.0-alt1
- New upstream release
- md-discover.patch updated for 2.3.0
- patches for 2.4.25 and 2.6.3 only

* Thu Mar 11 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt12
- Moved labels to macros
- Added engine-is_mounted patch

* Thu Mar  4 2004 Ed V. Bartosh <ed@altlinux.org> 2.2.2-alt11
- Changed directory name for the kernel patches (26 -> 2.6, 24 -> 2.4)

* Wed Mar  3 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt10
- Updated for 2.6.3

* Tue Mar  2 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt9
- md_discovery.c: flush cache before analyzing object
- raid1_discovery.c: prevent discovery in degraded mode

* Thu Feb 19 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt8
- Fixed symlinks

* Wed Feb 11 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt7
- special thanks to Sergey Bolshakov for nice scripting
- changed files order
- added conditional X
- added arm patches
- added additional config file
- changed init procedure

* Tue Feb 10 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt6
- Fixed library symlinks

* Mon Feb  9 2004 Pavel S. Mironchik <tibor@altlinux.ru> 2.2.2-alt5
- startup for rc.sysinit added

* Thu Feb  5 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt4
- Updated for 2.6.2
- removed /etc/evms.conf depend

* Thu Feb  5 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.2-alt3
- Added noncurses patch to remove ncurses depend for evms-cli

* Tue Feb 03 2004 Alexey Kotovich <a.kotovich@sam-solutions.net> 2.2.2-alt2
- delayed discovery patch was added
- print_value patch was adapted

* Mon Jan 19 2004 Alexey Kotovich <a.kotovich@sam-solutions.net> 2.2.2-alt1
- new release

* Thu Jan 15 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.1-alt5
- Adopted for 2.6.1

* Thu Jan 15 2004 Zhenja Kaluta <tren@altlinux.ru> 2.2.1-alt4
- Added 2.6 patches

* Tue Dec 16 2003 Zhenja Kaluta <tren@altlinux.ru> 2.2.1-alt3
- Adopted for 2.4.22 kernel

* Mon Dec 15 2003 Zhenja Kaluta <tren@altlinux.ru> 2.2.1-alt2
- removed some patches (adopted for 2.4.21)
- changed xfs vfs lock patch for aw kernel

* Fri Dec 12 2003 Alexey Kotovich <a.kotovich@sam-solutions.net> 2.2.1-alt1
- new release


